// C Source File
// Created 6/24/2002; 8:57:06 PM

#define USE_TI89              // Produce .89z File

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files

//This program took MANY days to create, so please, tell me what you think.  Do NOT steal my code because I'm not pretty when I'm angry (come to think of it, I was never pretty.) :)

int level=0;
int highl=0;

void winall(void){
	ClrScr();
	FontSetSys(F_8x10);
	printf_xy(16,0,"Congratulations!");//16
	printf_xy(28,10,"You have just");//13
	printf_xy(4,20,"completed 52 levels");//19
	printf_xy(4,30,"of Picross!  Thanks");//19
	printf_xy(4,40,"for downloading and");//19
	printf_xy(12,50,"playing one of my");//17
	printf_xy(56,60,"games!");//6
	printf_xy(8,80,"By:  Phil Software");//16
	printf_xy(36,90,"Press Enter");//11
	FontSetSys(F_6x8);
	while (!(_rowread(~((short)(1<<1))) & (1<<0)));
}

int newlevel(int l,int byten){
	static unsigned char sp0[]={0xFF,0x80,0xBF,0xA0,0xAF,0xA8,0xAB,0xAA};
	static unsigned char sp1[]={0x80,0xC0,0xE0,0xF0,0xF8,0xFC,0xFE,0xFF};
	static unsigned char sp2[]={0xFF,0xC3,0xA5,0x99,0x99,0xA5,0xC3,0xFF};
	static unsigned char sp3[]={0x3C,0x42,0xA5,0x81,0xA5,0x99,0x42,0x3C};
	static unsigned char sp4[]={0xBF,0xA0,0xAE,0xAA,0xAA,0xBA,0x82,0xFE};
	static unsigned char sp5[]={0xAA,0x55,0xAA,0x55,0xAA,0x55,0xAA,0x55};
	static unsigned char sp6[]={0x7C,0x7E,0x66,0x66,0x7E,0x7C,0x60,0x60};
	static unsigned char sp7[]={0xAA,0x7C,0xEE,0x54,0xEE,0x7C,0xAA,0x00};
	static unsigned char sp8[]={0x6C,0xFE,0xFE,0xFE,0x7C,0x38,0x10,0x00};
	static unsigned char sp9[]={0x3C,0x76,0xFF,0xFC,0xF8,0xFF,0x7E,0x3C};
	static unsigned char sp10[]={0x01,0x23,0x45,0x67,0x89,0xAB,0xCD,0xEF};
	static unsigned char sp11[]={0x42,0xA5,0x42,0x18,0x18,0x42,0xA5,0x42};
	static unsigned char sp12[]={0x40,0xA4,0x4A,0x04,0x44,0xA9,0x4A,0x49};
	static unsigned char sp13[]={0x38,0xED,0x05,0x0D,0x79,0x41,0x5D,0x77};
	static unsigned char sp14[]={0xFE,0xFD,0xFB,0xF7,0xEF,0xDF,0xBF,0x7F};
	static unsigned char sp15[]={0xE9,0xA9,0xEF,0x89,0x00,0xE8,0x48,0xEE};
	static unsigned char sp16[]={0xE1,0xCA,0x85,0x28,0x14,0xA1,0x53,0x87};
	static unsigned char sp17[]={0x80,0xBF,0xA1,0xAD,0xA5,0xBD,0x81,0xFF};
	static unsigned char sp18[]={0x85,0xAE,0xA1,0xAF,0xA1,0x95,0x24,0xED};
	static unsigned char sp19[]={0x8F,0xDA,0x88,0xE2,0x47,0x11,0x5B,0xF1};
	static unsigned char sp20[]={0x81,0x79,0xA7,0x64,0xD2,0x88,0x02,0xD8};
	static unsigned char sp21[]={0xFB,0x81,0x35,0x85,0xA1,0xAC,0x81,0xDF};
	static unsigned char sp22[]={0xFF,0xFF,0xAA,0x55,0x88,0xFF,0x55,0xAA};
	static unsigned char sp23[]={0xDB,0x99,0x24,0xC3,0xC3,0x24,0x99,0xDB};
	static unsigned char sp24[]={0xBF,0x80,0xA9,0xAD,0x89,0xBC,0x81,0xAD};
	static unsigned char sp25[]={0xBA,0xEB,0x09,0xEB,0xAA,0xBB,0x81,0xFF};
	static unsigned char sp26[]={0xA5,0x34,0xD3,0x06,0x60,0xCB,0x2C,0xA5};
	static unsigned char sp27[]={0xF1,0xCA,0x31,0x88,0x11,0x8C,0x53,0x8F};
	static unsigned char sp28[]={0x00,0x3C,0x5A,0x7E,0x3C,0x24,0x18,0x00};
	static unsigned char sp29[]={0xBB,0x5F,0xAE,0x5D,0xBA,0x75,0xEA,0xF5};
	static unsigned char sp30[]={0x56,0x59,0xA6,0x9A,0x65,0x95,0x6A,0xA9};
	static unsigned char sp31[]={0x55,0xBE,0x43,0xC2,0xC3,0xC2,0xFD,0xFA};
	static unsigned char sp32[]={0xA5,0x34,0xFF,0x3E,0x7C,0xFF,0x2C,0xA5};
	static unsigned char sp33[]={0xA5,0x4E,0xD1,0x44,0x22,0x8B,0x72,0xA5};
	static unsigned char sp34[]={0x00,0x24,0x24,0x24,0x00,0x81,0x42,0x3C};
	static unsigned char sp35[]={0xE4,0x72,0x39,0x9C,0x4E,0x27,0x93,0xC9};
	static unsigned char sp36[]={0xBA,0xEE,0x00,0xAA,0x55,0x00,0xEE,0xBA};
	static unsigned char sp37[]={0xDB,0xBD,0x7E,0xE7,0xE7,0x7E,0xBD,0xDB};
	static unsigned char sp38[]={0x42,0xFF,0x42,0x5A,0x5A,0x42,0xFF,0x42};
	static unsigned char sp39[]={0xA5,0x66,0xFF,0x3C,0x3C,0xFF,0x66,0xA5};
	static unsigned char sp40[]={0xE7,0x95,0x9B,0x74,0x2E,0xD9,0xA9,0xE7};
	static unsigned char sp41[]={0xD5,0xEA,0x75,0xBA,0x5D,0xAE,0x57,0xAB};
	static unsigned char sp42[]={0xE7,0x8A,0x5C,0x6A,0x56,0x3A,0x51,0xE7};
	static unsigned char sp43[]={0xAB,0xEA,0x03,0xD8,0x1B,0xC0,0x57,0xD5};
	static unsigned char sp44[]={0xBC,0xA5,0x01,0x99,0x98,0x81,0x3D,0xA5};
	static unsigned char sp45[]={0x38,0x74,0x7C,0x38,0x44,0x38,0x44,0x38};
	static unsigned char sp46[]={0x66,0x99,0x81,0x66,0x18,0x66,0x81,0x7E};
	static unsigned char sp47[]={0xEE,0x00,0x77,0x00,0xBB,0x00,0xDD,0x00};
	static unsigned char sp48[]={0x6D,0x50,0xDD,0x78,0x4A,0x61,0x36,0x47};
	static unsigned char sp49[]={0x7E,0x81,0xA5,0x81,0xA5,0xBD,0x81,0x7E};
	static unsigned char sp50[]={0x93,0xF2,0x26,0x1B,0xD8,0x64,0x4F,0xC9};
	static unsigned char sp51[]={0x60,0x84,0xAA,0x64,0x00,0x44,0xAC,0x4C};
	if (l>51){level=0;l=0;}
	if (l==0){return sp0[byten];}
	if (l==1){return sp1[byten];}
	if (l==2){return sp2[byten];}
	if (l==3){return sp3[byten];}
	if (l==4){return sp4[byten];}
	if (l==5){return sp5[byten];}
	if (l==6){return sp6[byten];}
	if (l==7){return sp7[byten];}
	if (l==8){return sp8[byten];}
	if (l==9){return sp9[byten];}
	if (l==10){return sp10[byten];}
	if (l==11){return sp11[byten];}
	if (l==12){return sp12[byten];}
	if (l==13){return sp13[byten];}
	if (l==14){return sp14[byten];}
	if (l==15){return sp15[byten];}
	if (l==16){return sp16[byten];}
	if (l==17){return sp17[byten];}
	if (l==18){return sp18[byten];}
	if (l==19){return sp19[byten];}
	if (l==20){return sp20[byten];}
	if (l==21){return sp21[byten];}
	if (l==22){return sp22[byten];}
	if (l==23){return sp23[byten];}
	if (l==24){return sp24[byten];}
	if (l==25){return sp25[byten];}
	if (l==26){return sp26[byten];}
	if (l==27){return sp27[byten];}
	if (l==28){return sp28[byten];}
	if (l==29){return sp29[byten];}
	if (l==30){return sp30[byten];}
	if (l==31){return sp31[byten];}
	if (l==32){return sp32[byten];}
	if (l==33){return sp33[byten];}
	if (l==34){return sp34[byten];}
	if (l==35){return sp35[byten];}
	if (l==36){return sp36[byten];}
	if (l==37){return sp37[byten];}
	if (l==38){return sp38[byten];}
	if (l==39){return sp39[byten];}
	if (l==40){return sp40[byten];}
	if (l==41){return sp41[byten];}
	if (l==42){return sp42[byten];}
	if (l==43){return sp43[byten];}
	if (l==44){return sp44[byten];}
	if (l==45){return sp45[byten];}
	if (l==46){return sp46[byten];}
	if (l==47){return sp47[byten];}
	if (l==48){return sp48[byten];}
	if (l==49){return sp49[byten];}
	if (l==50){return sp50[byten];}
	if (l==51){return sp51[byten];}
	return 0;////////////////////////////////This line could probably be taken out
}

void invert_scr(void)//Routine from Cave Blaster
{
  register long *ptr;
  for(ptr=(long*)0x4c00;(unsigned long)ptr<=0x57b8;*ptr++^=-1);
}

void erasetop(int x){
	printf_xy(x*8+88,1," ");
	printf_xy(x*8+88,10," ");
	printf_xy(x*8+88,18," ");
	printf_xy(x*8+88,26," ");
}

void eraseleft(int y){
	printf_xy(70,y*8+28,"    ");
}

void addtop(int g1,int g2,int g3,int g4,int x){//x=x*8+88;y=y*8+28;
	FontSetSys(F_6x8);
	if (g4>0){
		printf_xy(x*8+88,1,"%d",g1);
		printf_xy(x*8+88,10,"%d",g2);
		printf_xy(x*8+88,18,"%d",g3);
		printf_xy(x*8+88,26,"%d",g4);
		return;
	}
	if (g3>0){
		printf_xy(x*8+88,10,"%d",g1);
		printf_xy(x*8+88,18,"%d",g2);
		printf_xy(x*8+88,26,"%d",g3);
		return;
	}
	if (g2>0){
		printf_xy(x*8+88,18,"%d",g1);
		printf_xy(x*8+88,26,"%d",g2);
		return;
	}
	if (g1>0) printf_xy(x*8+88,26,"%d",g1);
}

void addleft(int g1,int g2,int g3,int g4,int y){
	FontSetSys(F_6x8);
	if (g4>0){
		printf_xy(70,y*8+28,"%d",g4);
		printf_xy(76,y*8+28,"%d",g3);
		printf_xy(82,y*8+28,"%d",g2);
		printf_xy(88,y*8+28,"%d",g1);
		return;
	}
	if (g3>0){
		printf_xy(76,y*8+28,"%d",g3);
		printf_xy(82,y*8+28,"%d",g2);
		printf_xy(88,y*8+28,"%d",g1);
		return;
	}
	if (g2>0){
		printf_xy(82,y*8+28,"%d",g2);
		printf_xy(88,y*8+28,"%d",g1);
		return;
	}
	if (g1>0) printf_xy(88,y*8+28,"%d",g1);
}

void delay(void) {
	short int loop = 1000, randNum;
	
	// generate random numbers to slow down the program...
	while (loop-- > 0) {
		randNum = rand() % loop;
	}
}

void drawblock(int x,int y){
	int a;
	x=x*8+88;y=y*8+28;
	for (a=x;a<=x+6;a++){
		DrawLine(a,y,a,y+6,A_XOR);
	}
}

// Main Function
void _main(void)
{
	int a,b;
	int x,y,key;
	int keyp=0;
	int waitkey=1;
	int waitkeyu=1;
	int waitkeyd=1;
	int waitkeyl=1;
	int waitkeyr=1;
	int p2nd=0;
	int lastone;
	int numgroup;
	int g1,g2,g3,g4;
	int time;
	int win;
	int curr;
	int quitting=0;
	static unsigned char current[]={0,0,0,0,0,0,0,0};
	static unsigned char arrow[]={0xE0,0xC0,0xA0,0x10,0x08,0x00,0x00,0x00};
	//static unsigned char let_p[]={0x7C,0x7E,0x66,0x66,0x7E,0x7C,0x60,0x60};//static unsigned char let_i[]={0x3C,0x18,0x18,0x18,0x18,0x18,0x18,0x3C};//static unsigned char let_c[]={0x3C,0x7E,0x66,0x60,0x60,0x66,0x7E,0x3C};//static unsigned char let_r[]={0x7C,0x7E,0x66,0x66,0x7E,0x7C,0x66,0x66};//static unsigned char let_o[]={0x3C,0x7E,0x66,0x66,0x66,0x66,0x7E,0x3C};//static unsigned char let_s[]={0x3C,0x7E,0x66,0x30,0x0E,0x66,0x7E,0x3C};
	static unsigned short int p1[]={0xFF87,0xFFC7,0xFFE7,0xE0E1,0xE0E1,0xE0E1,0xE0E1,0xE0E1,0xFFE1,0xFFC1,0xFF81,0xE001,0xE001,0xE007,0xE007,0xE007};
	static unsigned short int p2[]={0xF03E,0xF07F,0xF0FF,0xC1E1,0xC3C0,0xC380,0xC380,0xC380,0xC380,0xC380,0xC380,0xC3C0,0xC1E1,0xF0FF,0xF07F,0xF03E};
	static unsigned short int p3[]={0x1FF0,0x1FF8,0x9FFC,0x9C1C,0x1C1C,0x1C1C,0x1C1C,0x1C1C,0x1FFC,0x1FF8,0x1FF0,0x1FE0,0x9CF0,0x9C78,0x1C3C,0x1C1C};
	static unsigned short int p4[]={0x1F03,0x3F87,0x7FCF,0xF1EE,0xE0EE,0xE0EE,0xE0EF,0xE0EF,0xE0E7,0xE0E3,0xE0E0,0xE0EC,0xF1EE,0x7FCF,0x3F8F,0x1F07};
	static unsigned short int p5[]={0xF07E,0xF8FF,0xF9FF,0x39C7,0x19C3,0x01C0,0xE1FC,0xF1FE,0xF8FF,0xF87F,0x3807,0x3987,0x39C7,0xF9FF,0xF1FE,0xE0FC};
	ClrScr();
	FontSetSys(F_8x10);
	printf_xy(28,20,"Level Number:");
	FontSetSys(F_6x8);
	for (a=0;a<3;a++){
		if (kbhit()){
			ngetchx();
		}
	}
	if (highl>0){
		curr=0;
		printf_xy(74,50,"00");//62 '<' 74,80 level 92 '>'
		printf_xy(92,50,">");
		while ((key=ngetchx())!=KEY_ENTER){
			if (key==KEY_ESC||key==KEY_CLEAR){
				exit(0);
			}
			if (key==KEY_LEFT&&curr>0){
				curr--;
			}
			if (key==KEY_RIGHT&&curr<highl){
				curr++;
			}
			if (curr>0){
				printf_xy(62,50,"<");
			}else{
				printf_xy(62,50," ");
			}
			if (curr<highl){
				printf_xy(92,50,">");
			}else{
				printf_xy(92,50," ");
			}
			if (curr<10){
				printf_xy(74,50,"0%d",curr);
			}else{
				printf_xy(74,50,"%d",curr);
			}
		}
		level=curr;
	}	
	INT_HANDLER interrupt1 = GetIntVec(AUTO_INT_1);
	SetIntVec(AUTO_INT_1,DUMMY_HANDLER);
StartAgain:
	ClrScr();
	for (x=35;x<=99;x+=8){//horizontal lines
		DrawLine(95,x,159,x,A_NORMAL);
	}
	for (x=95;x<=159;x+=8){//vertical lines
		DrawLine(x,35,x,99,A_NORMAL);
	}
	DrawLine(0,35,95,35,A_NORMAL);
	DrawLine(95,0,95,35,A_NORMAL);
	DrawLine(68,35,68,99,A_NORMAL);
	x=1;y=1;
	time=1000;
	win=0;
	Sprite8(x*8+88,y*8+28,8,arrow,LCD_MEM,SPRT_XOR);
	for (a=0;a<=7;a++){
		current[a]=newlevel(level,a);
	}
	lastone=2;numgroup=0;g1=0;g2=0;g3=0;g4=0;
	for (a=0;a<=7;a++){
		if (!(current[a]&1<<(8-x))){
			if (lastone==1) numgroup++;
			lastone=0;
		}else{
			if (numgroup==0){g1++;}
			if (numgroup==1){g2++;}
			if (numgroup==2){g3++;}
			if (numgroup==3){g4++;}
			lastone=1;
		}
	}
	addtop(g1,g2,g3,g4,x);
	lastone=2;numgroup=0;g1=0;g2=0;g3=0;g4=0;
	for (a=0;a<=7;a++){
		if (!(current[y-1]&1<<a)){
			if (lastone==1) numgroup++;
			lastone=0;
		}else{
			if (numgroup==0){g1++;}
			if (numgroup==1){g2++;}
			if (numgroup==2){g3++;}
			if (numgroup==3){g4++;}
			lastone=1;
		}
	}
	addleft(g1,g2,g3,g4,y);
	FontSetSys(F_8x10);
	printf_xy(0,57,"Level:");
	printf_xy(0,67,"%d",level);
	FontSetSys(F_6x8);
	//Add PICROSS
	Sprite16(7,2,16,p1,LCD_MEM,SPRT_XOR);
	Sprite16(23,2,16,p2,LCD_MEM,SPRT_XOR);
	Sprite16(39,2,16,p3,LCD_MEM,SPRT_XOR);
	Sprite16(55,2,16,p4,LCD_MEM,SPRT_XOR);
	Sprite16(71,2,16,p5,LCD_MEM,SPRT_XOR);
	//Old place for disabling Interrupt1
	printf_xy(38,19,"By:");
	printf_xy(8,27,"Phil Software");
	while (1==1){
		key=_rowread(0xFFFE);
		if (key&0x0001&&waitkeyu==1){//up
			keyp=8;
			waitkeyu=0;
		}
		if ((key&0x0001)==0){
			waitkeyu=1;
		}
		if (key&0x0002&&waitkeyl==1){//left
			keyp=4;
			waitkeyl=0;
		}
		if ((key&0x0002)==0){
			waitkeyl=1;
		}
		if (key&0x0004&&waitkeyd==1){//down
			keyp=2;
			waitkeyd=0;
		}
		if ((key&0x0004)==0){
			waitkeyd=1;
		}
		if (key&0x0008&&waitkeyr==1){//right
			keyp=6;
			waitkeyr=0;
		}
		if ((key&0x0008)==0){
			waitkeyr=1;
		}
		if (key&0x0010&&waitkey==1){//2nd
			p2nd=1;
			waitkey=0;
		}
		if ((key&0x0010)==0){
			waitkey=1;
		}
		if (keyp==4&&x!=1){//left
			erasetop(x);
			Sprite8(x*8+88,y*8+28,8,arrow,LCD_MEM,SPRT_XOR);
			x--;
			Sprite8(x*8+88,y*8+28,8,arrow,LCD_MEM,SPRT_XOR);
			lastone=2;numgroup=0;g1=0;g2=0;g3=0;g4=0;
			for (a=0;a<=7;a++){
				if (!(current[a]&1<<(8-x))){
					if (lastone==1) numgroup++;
					lastone=0;
				}else{
					if (numgroup==0){g1++;}
					if (numgroup==1){g2++;}
					if (numgroup==2){g3++;}
					if (numgroup==3){g4++;}
					lastone=1;
				}
			}
			addtop(g1,g2,g3,g4,x);
		}
		if (keyp==6&&x!=8){
			erasetop(x);
			Sprite8(x*8+88,y*8+28,8,arrow,LCD_MEM,SPRT_XOR);
			x++;
			Sprite8(x*8+88,y*8+28,8,arrow,LCD_MEM,SPRT_XOR);
			lastone=2;numgroup=0;g1=0;g2=0;g3=0;g4=0;
			for (a=0;a<=7;a++){
				if (!(current[a]&1<<(8-x))){
					if (lastone==1) numgroup++;
					lastone=0;
				}else{
					if (numgroup==0){g1++;}
					if (numgroup==1){g2++;}
					if (numgroup==2){g3++;}
					if (numgroup==3){g4++;}
					lastone=1;
				}
			}
			addtop(g1,g2,g3,g4,x);
		}
		if (keyp==8&&y!=1){
			eraseleft(y);
			Sprite8(x*8+88,y*8+28,8,arrow,LCD_MEM,SPRT_XOR);
			y--;
			Sprite8(x*8+88,y*8+28,8,arrow,LCD_MEM,SPRT_XOR);
			lastone=2;numgroup=0;g1=0;g2=0;g3=0;g4=0;
			for (a=0;a<=7;a++){
				if (!(current[y-1]&1<<a)){
					if (lastone==1) numgroup++;
					lastone=0;
				}else{
					if (numgroup==0){g1++;}
					if (numgroup==1){g2++;}
					if (numgroup==2){g3++;}
					if (numgroup==3){g4++;}
					lastone=1;
				}
			}
			addleft(g1,g2,g3,g4,y);
		}
		if (keyp==2&&y!=8){
			eraseleft(y);
			Sprite8(x*8+88,y*8+28,8,arrow,LCD_MEM,SPRT_XOR);
			y++;
			Sprite8(x*8+88,y*8+28,8,arrow,LCD_MEM,SPRT_XOR);
			lastone=2;numgroup=0;g1=0;g2=0;g3=0;g4=0;
			for (a=0;a<=7;a++){
				if (!(current[y-1]&1<<a)){
					if (lastone==1) numgroup++;
					lastone=0;
				}else{
					if (numgroup==0){g1++;}
					if (numgroup==1){g2++;}
					if (numgroup==2){g3++;}
					if (numgroup==3){g4++;}
					lastone=1;
				}
			}
			addleft(g1,g2,g3,g4,y);
		}
		if (p2nd==1){
			if (current[y-1]&1<<(8-x)){
				drawblock(x,y);
				g1=1;
				for (a=0;a<=7;a++){
					for (b=0;b<=7;b++){
						if (current[b]&1<<(7-a)){
							if (!GetPix((a+1)*8+94,(b+1)*8+34)){
								g1=0;
							}
						}
					}
				}
				if (g1){
					win=1;break;
				}
			}else{
				time-=40;
				if (time<1){time=1;}
				//I think I should display 'miss'... make delay... erase miss, put miss on side so won't affect game
			}
		}
		p2nd=0;
		keyp=0;
		time--;
		FontSetSys(F_8x10);
		printf_xy(0,37,"Time:");
		printf_xy(0,47,"%d ",time);
		FontSetSys(F_6x8);
		if (time<=0){
			break;
		}
		if (_rowread(~((short)(1<<1))) & (1<<6)){
			quitting=1;break;
		}
		if (_rowread(~((short)(1<<4))) & (1<<6)){
			off();
		}
		delay();
	}
	if (!quitting){
		if (win==1){
			win=0;
			if (level<51){
				level++;
			}
			if (highl<level){
				highl=level;
			}
			FontSetSys(F_8x10);
			printf_xy(48,45,"You win!");
			FontSetSys(F_6x8);
			for (a=0;a<500;a++){
				invert_scr();
			}
			for (a=0;a<=25;a++){
				delay();
			}
			if (level==52){
				level=0;winall();SetIntVec(AUTO_INT_1,interrupt1);for (a=0;a<=1;a++){delay();}if (kbhit()){ngetchx();exit(0);}
			}
			goto StartAgain;
		}
		FontSetSys(F_8x10);
		printf_xy(44,45,"You lose!");
		for (a=0;a<500;a++){
			invert_scr();
		}
		randomize();
		for (a=0;a<=32765;a++){
			DrawPix(random(160),random(100),A_REVERSE);
		}
		ClrScr();
		SetIntVec(AUTO_INT_1,interrupt1);
		if (kbhit()){
			ngetchx();
		}
	}
	SetIntVec(AUTO_INT_1,interrupt1);
	for (a=0;a<=1;a++){
		delay();
	}
	if (kbhit()){
		ngetchx();
	}
}
